from flask import current_app, jsonify, request
from flask_restful import Resource
from flask_restful.reqparse import RequestParser
from flask_jwt_extended import ( jwt_required, get_jwt_identity )
from application.signal_manager import signalManager
{%- set pipe = joiner(",") %}
from models.{{ config['name'] }} import {% for k, v in config["view"].items() -%}
<<<<<<< HEAD
{{ pipe() }}{{ k }}{{ config['name'] | letterUpper }}Schema
{%- endfor %}
=======
{{ pipe() }}{{ k }}{{ config['name'] | letterUpper }}Schema{% if k == "getList" %}{{ pipe() }}{{ k }}{{ config['name'] | letterUpper }}sSchema{% endif %}
{%- endfor %}
from webcreator.log import logger
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
from webcreator.response import ResponseCode, response_result

class {{ config['name'] | letterUpper }}ResourceList(Resource):
    def __init__(self):
        pass
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser = RequestParser()

{%- if config["view"]["getList"] %}
{% if config["view"]["getList"]["auth"] %}
<<<<<<< HEAD
    @jwt_required
=======
    @jwt_required(locations=["headers"])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
{%- endif %}
    def get(self):
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser.add_argument("page", type=int, location="args", default=1)
        # self.parser.add_argument("pageSize", type=int, location="args", default=15)
        # args = self.parser.parse_args()

        try:
            json_payload = request.json
<<<<<<< HEAD
            print("========>", json_payload)
            data = getList{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionGet{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = getList{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
=======
            logger.warn(json_payload)
            data = getList{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionGetList{{ config["name"] | letterUpper }}.emit(data)
            json_dumps = getList{{ config['name'] | letterUpper }}Schema.dump(result)
            if result[0]:
                json_dumps = getList{{ config['name'] | letterUpper }}sSchema.dump(result[1])
                logger.warn(json_dumps)
                return response_result(ResponseCode.OK, data=json_dumps, count=result[2])
            return response_result(ResponseCode.REQUEST_ERROR)
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)
{%- endif %}

{%- if config["view"]["post"] %}
{% if config["view"]["post"]["auth"] %}
<<<<<<< HEAD
    @jwt_required
=======
    @jwt_required(locations=["headers"])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
{%- endif %}
    def post(self):
        try:
            json_payload = request.json
            data = post{{ config['name'] | letterUpper }}Schema.load(json_payload)
<<<<<<< HEAD
            result = signalManager.actionPost{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = post{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
=======
            result = signalManager.actionPost{{ config["name"] | letterUpper }}.emit(data)
            if result[0] == False:
                # json_dumps = post{{ config["name"] | letterUpper }}Schema.dump(result)
                return response_result(ResponseCode.REQUEST_ERROR, msg=result[1])
            logger.warn(result)
            return response_result(ResponseCode.OK)
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)
{% endif %}

class {{ config['name'] | letterUpper }}Resource(Resource):
    def __init__(self):
        pass
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser = RequestParser()

{%- if config["view"]["get"] %}
{% if config["view"]["get"]["auth"] %}
<<<<<<< HEAD
    @jwt_required
=======
    @jwt_required(locations=["headers"])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
{%- endif %}
    def get(self, uuid):
        # 特殊参数，即不是从json获取参数的接口，可以将这个注释打开
        # self.parser.add_argument("page", type=int, location="args", default=1)
        # self.parser.add_argument("pageSize", type=int, location="args", default=15)
        # args = self.parser.parse_args()

        try:
            json_payload = request.json
            print("========>", uuid, json_payload)
            data = get{{ config['name'] | letterUpper }}Schema.load(json_payload)
<<<<<<< HEAD
            result = signalManager.actionGet{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = get{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
=======
            result = signalManager.actionGet{{ config["name"] | letterUpper }}.emit(uuid, data)
            if result[0]:
                json_dumps = get{{ config['name'] | letterUpper }}Schema.dump(result[1])
                return response_result(ResponseCode.OK, data=json_dumps)
            return response_result(ResponseCode.NO_DATA)
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)
{% endif %}

{%- if config["view"]["put"] %}
{% if config["view"]["put"]["auth"] %}
<<<<<<< HEAD
    @jwt_required
=======
    @jwt_required(locations=["headers"])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
{%- endif %}
    def put(self, uuid):
        try:
            json_payload = request.json
            print("========>", uuid, json_payload)
            data = put{{ config['name'] | letterUpper }}Schema.load(json_payload)
<<<<<<< HEAD
            result = signalManager.actionPut{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = put{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
=======
            result = signalManager.actionPut{{ config["name"] | letterUpper }}.emit(uuid, data)
            if result[0] == True:
                # json_dumps = put{{ config['name'] | letterUpper }}Schema.dump(result)
                return response_result(ResponseCode.OK)
            return response_result(ResponseCode.NOTHING_CHANGE, msg=result[1])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)
{% endif %}

{%- if config["view"]["delete"] %}
{% if config["view"]["delete"]["auth"] %}
<<<<<<< HEAD
    @jwt_required
=======
    @jwt_required(locations=["headers"])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
{%- endif %}
    def delete(self, uuid):
        try:
            json_payload = request.json
            print("========>", uuid, json_payload)
<<<<<<< HEAD
            data = delete{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionDelete{{ config["name"] | letterUpper }}.emit(**data)
            json_dumps = delete{{ config['name'] | letterUpper }}Schema.dump(result)
            return jsonify(json_dumps), 200
=======
            # data = delete{{ config['name'] | letterUpper }}Schema.load(json_payload)
            result = signalManager.actionDelete{{ config["name"] | letterUpper }}.emit(uuid)
            if result[0] == True:
                return response_result(ResponseCode.OK)
            return response_result(ResponseCode.REQUEST_ERROR, msg=result[1])
>>>>>>> 735d39eb4d0c3134b62bf4fe1b7a2ca0ea8da1ca
        except Exception as e:
            current_app.logger.error(e)
            return response_result(ResponseCode.DB_ERROR)
{% endif %}